(function() {
        // Load plugin specific language pack
        //tinymce.PluginManager.requireLangPack('example');

        tinymce.create('tinymce.plugins.sociallockplugin', {
                /**
                 * Initializes the plugin, this will be executed after the plugin has been created.
                 * This call is done before the editor instance has finished it's initialization so use the onInit event
                 * of the editor instance to intercept that event.
                 *
                 * @param {tinymce.Editor} ed Editor instance that the plugin is initialized in.
                 * @param {string} url Absolute URL to where the plugin is located.
                 */
                init : function(ed, url) {

			var slLoaded = false,
			    slOpen = function() {
				ed.windowManager.open({
				    // uses id that is existing in html for content
				    id : 'social_lock_dialog',
				    width : 500,
				    height : 400,
				    wpDialog : true,
				    inline : 1,
				    title: "Social Lock"
				 });
			    }
                        // Register the command so that it can be invoked by using tinyMCE.activeEditor.execCommand('mceExample');
               ed.addCommand('wptb_tinyplugin', function() {
				if (slLoaded) {
				    slOpen();
				    return;
				};
				jQuery.ajax({
				  url: ajaxurl + "?action=sl_post_dialog",
				  success: function(data){
				      jQuery('body').append(data);
				      slOpen();
				      slLoaded = true;
				  }
				});
				
				});

                        // Register example button
                        ed.addButton('sociallockplugin', {
                                title : 'Social Lock : Insert Your Links',
                                cmd : 'wptb_tinyplugin',
                                image : url + "/../images/button.png"
                        });

                        // Add a node change handler, selects the button in the UI when a image is selected
                        ed.onNodeChange.add(function(ed, cm, n) {
                                cm.setActive('example', n.nodeName == 'IMG');
                        });
                },

                /**
                 * Returns information about the plugin as a name/value array.
                 * The current keys are longname, author, authorurl, infourl and version.
                 *
                 * @return {Object} Name/value array containing information about the plugin.
                 */
                getInfo : function() {
                        return {
                                longname : 'Social Lock',
                                author : 'Rohit Chowdhary',
                                authorurl : 'http://buffernow.com',
                                infourl : 'http://buffernow.com',
                                version : "1.0"
                        };
                }
        });

        // Register plugin
        tinymce.PluginManager.add('sociallockplugin', tinymce.plugins.sociallockplugin);
})();
